models/Ordenadores.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "ordenadores".
 *
 * @property int $id
 * @property string|null $descripcion
 * @property string|null $procesador
 * @property string|null $memoria
 * @property string|null $discoduro
 * @property int|null $ethernet
 * @property int|null $wifi
 * @property string|null $video
 */
class Ordenadores extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ordenadores';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['ethernet', 'wifi'], 'integer'],
            [['descripcion'], 'string', 'max' => 800],
            [['procesador', 'memoria', 'discoduro', 'video'], 'string', 'max' => 100],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'descripcion' => 'Descripcion',
            'procesador' => 'Procesador',
            'memoria' => 'Memoria RAM',
            'discoduro' => 'Disco duro',
            'ethernet' => 'Tarjeta de red Ethernet',
            'wifi' => 'Tarjeta de red Wifi',
            'video' => 'Tarjeta Video',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Ordenadores;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionAdministrar()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Ordenadores::find()]);
        return $this->render("administrar",["dataProvider" => $dataProvider]);
    }
    
    public function actionAnadir()
    {
        $model = new Ordenadores();
        $titulo="AÑADIR ORDENADOR";
        $accion="Añadir";
        
        if($this->request->isPost) //si ya hay datos del formulario
        {
            if ($model->load(Yii::$app->request->post())) {
                if ($model->save()) 
                {
                    return $this->redirect(["site/administrar"]);
                }
            }
        }
        return $this->render('formulario', [
            'model' => $model,
            'titulo' => $titulo,
            'accion' => $accion,
        ]);
    }
    
    public function actionActualizar($id)
    {
        $model = Ordenadores::findOne($id);
        $titulo="ACTUALIZAR DATOS DEL ORDENADOR";
        $accion="Actualizar";

        if ($model->load(Yii::$app->request->post())) {
            if ($model->save()) 
            {
                return $this->redirect(["site/administrar"]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
            'titulo' => $titulo,
            'accion' => $accion,
        ]);
    }
    
    public function actionEliminar($id)
    {
        $model = Ordenadores::findOne($id);
        $titulo="<i class='fas fa-trash fa-5x'></i> ELIMINAR ORDENADOR";
        $accion="Eliminar";

        if ($model->load(Yii::$app->request->post())) {
            $model->delete();
            return $this->redirect(["site/administrar"]);
            
        }

        return $this->render('formulario', [
            'model' => $model,
            'titulo' => $titulo,
            'accion' => $accion,
        ]);
    }
    
    public function actionListar()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Ordenadores::find(),
            'pagination' => [
        'pageSize' => 6,
        ],
            ]);
        return $this->render("listar",["dataProvider" => $dataProvider]);
    }
    
    public function actionVer($id)
    {
        $model= Ordenadores::findOne($id);
        return $this->render("ver",["model"=> $model]);
    }
    
    public function actionVeracordeon($id)
    {
        $red="";
        $model= Ordenadores::findOne($id);
        if($model->ethernet && $model->wifi)
        {
            $red=["Ethernet", "Wifi"];
        }elseif($model->ethernet && !$model->wifi)
        {
            $red="Ethernet";
        }elseif(!$model->ethernet && $model->wifi)
        {
            $red="Wifi";
        }
        return $this->render("veracordeon",["model"=> $model,"red"=> $red]);
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'encodeLabels' => false, //para que funcionen los dibujos del menu
        'items' => [
            ['label' => '<i class="fas fa-check-square"></i> ADMINISTRAR', 'url' => ['/site/administrar']],
            ['label' => '<i class="fas fa-list"></i> LISTAR', 'url' => ['/site/listar']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container text-center">
        <i class="fas fa-copyright"></i> Copyright
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_listar.php
<?php
use yii\helpers\Html;
use app\widgets\Modal;
?>

<table>
    <tr><td colspan="2"><?= $model->id?></td><td><?= substr($model->descripcion,0,10) . "..." ?><td></tr>
    <tr><td><?= Html::a('<i class="fas fa-plus-circle"></i>',['site/ver','id' => $model->id],['class' => 'botonModal']) ?></td></tr>
</table>

<?php
echo Modal::widget();
?>

views/site/administrar.php
<?php

use yii\grid\GridView;
use yii\bootstrap4\Html;

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'layout' =>"{items}", //para evitar que salga Mostrando 1-4 de 4 elementos.
    'columns' => [
        'id',
        'descripcion',
        'procesador',
        'memoria',
        'discoduro',
        [
            'attribute'=>'ethernet',
            'format'=>'raw',
            'content'=>function($model){
                //return Html::activeCheckbox($model, "ethernet",['disabled'=>true]);
                if($model->ethernet)
                {
                    return '<i class="far fa-check-square"></i>';
                }else
                {
                    return '<i class="far fa-square"></i>';
                }
                
            }
        ],
        [
            'attribute'=>'wifi',
            'format'=>'raw',
            'value'=>function($data){
                if($data->wifi==1)
                {
                    return '<i class="far fa-check-square"></i>';
                }else
                {
                    return '<i class="far fa-square"></i>';
                }
                
            }
        ],
        'video',
                
        [
            'header' => 'Acciones',
            'headerOptions' => ['class' => 'btn-link font-weight-bold'],
            'class' => 'yii\grid\ActionColumn',
                'template' => '{delete} {update} {view} {new}',  //orden de los botones    
                'buttons' => [
                'view' => function($url,$model){
                return Html::a('<i class="fas fa-eye"></i>',['site/ver','id' => $model->id]);
                },
                'update' => function($url,$model){
                    return Html::a('<i class="fas fa-pencil-alt"></i>',['site/actualizar','id' => $model->id]);
                    },
                'delete' => function($url,$model){
                    return Html::a('<i class="fas fa-trash-alt"></i>',['site/eliminar','id' => $model->id]);
                    }, 
                'new' => function($url,$model){
                    return Html::a('<i class="fas fa-plus"></i>',['site/anadir','id' => $model->id]);
                    },
                            
            ]],
    ]]);

?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\switchinput\SwitchInput;

/* @var $this yii\web\View */
/* @var $model app\models\Ordenadores */
/* @var $form ActiveForm */
?>
<div class="formulario">
    
    <h4><u><?= $titulo ?></u></h4>

<?php
$opciones=[
    "template"=> '{input}{label}',
    "inputOptions" => ['class' => 'col-lg-9'],
    "labelOptions" => ['class' => 'col-lg-2'],
    "options" => ["class" => "row mb-2"],
];

$opciones1=[
            'template' => '{label}{input}',
            'inputOptions' => ['class'=>'col-lg-9 p-0'],
            'labelOptions' => ['class'=>'col-lg-1 p-0'],
            'options' => ['form-check form-inline']
        ];

?>

    <?php $form = ActiveForm::begin(); ?>
        
        <?= $form->field($model, 'descripcion',$opciones)->textarea(["rows"=>6]) ?>
        <?= $form->field($model, 'procesador',$opciones) ?>
        <?= $form->field($model, 'memoria',$opciones) ?>
        <?= $form->field($model, 'discoduro',$opciones) ?>
        <?php //$form->field($model, 'ethernet',$opciones1)->checkbox(['class'=>'form-check-input'],false) ?>
        <?= $form->field($model, 'ethernet')->widget(SwitchInput::classname(),['pluginOptions' => ['onText' => 'Con Ethernet', 'offText' => 'Sin Ethernet']])->label('')?>
        <?= $form->field($model, 'wifi')->widget(SwitchInput::classname(),['pluginOptions' => ['onText' => 'Con Wifi', 'offText' => 'Sin Wifi']])->label('') ?>
        <?= $form->field($model, 'video',$opciones) ?>
    
        <div class="form-group">
            <?= Html::submitButton($accion, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- formulario -->

views/site/index.php
<?php
use yii\helpers\Html;

/* @var $this yii\web\View */

$this->title = 'Gestion de ordenadores';
?>
<table>
    <tr><td><?= Html::img('@web/imgs/ordenador.jpg'); ?></td>
<td>

<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
    fugiat nulla pariatur.</p>
</td></tr>
</table>

                

views/site/listar.php
<?php

use yii\widgets\ListView;

echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => '_listar',
    "options" => [
        "class" => "row"
    ],
    "itemOptions" => [
        "class" => "col-lg-3 border m-2 p-2",
    ],
    ]);

?>

views/site/ver.php
<?php
use yii\widgets\DetailView;
use yii\helpers\Html;
?>

<h4><u>DATOS DEL ORDENADOR</u></h4>

<?php
echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'id',
        'descripcion',
        'procesador',
        'memoria',
        'discoduro',
        [
            'attribute'=>'ethernet',
            'format'=>'raw',
            'value'=>function($data){
                if($data->ethernet==1)
                {
                    return '<i class="far fa-check-square"></i>';
                }else
                {
                    return '<i class="far fa-square"></i>';
                }
                
            }
        ],
        [
            'attribute'=>'wifi',
            'format'=>'raw',
            'value'=>function($data){
                if($data->wifi==1)
                {
                    return '<i class="far fa-check-square"></i>';
                }else
                {
                    return '<i class="far fa-square"></i>';
                }
                
            }
        ],
        'video',
            ]
]);

echo "<br>";        
echo Html::a("VER POR BLOQUES",["site/veracordeon",'id' => $model->id], ['class' => 'btn btn-primary']) 
        
?>

views/site/veracordeon.php
<?php
use yii\bootstrap4\Accordion;
use yii\helpers\Html;

echo Accordion::widget([
    'items' => [
        // equivalent to the above
        [
            'label' => $model->getAttributeLabel("descripcion"),
            'content' => $model->descripcion,
            'expand' => true,
        ],
        // another group item
        [
            'label' => $model->getAttributeLabel("procesador"),
            'content' => $model->procesador,
        ],
        [
            'label' => $model->getAttributeLabel("memoria"),
            'content' => $model->memoria,
        ],
        [
            'label' => 'Red',
            'content' => $red,
        ],
        // if you want to swap out .card-block with .list-group, you may use the following
        [
            'label' => $model->getAttributeLabel("video"),
            'content' => $model->video,
        ],
    ]
]);


echo "<br>";        
echo Html::a("VER NORMAL",["site/ver",'id' => $model->id], ['class' => 'btn btn-primary']); 